#include "Vram.h"
#include "Chars.h"
#include "Sprite.h"

extern byte[] MonoPattern, ColorPattern, SpritePattern;

void InitVram()
{
    ClearScreen();
    SetPcgMono(Char_Ascii, MonoPattern, 7, 64);
    SetPcgMono(Char_Logo, MonoPattern + Char_Logo * CharHeight, 5, 16);
    SetPcgMono(Char_Fence, MonoPattern + Char_Fence * CharHeight, 1, 3);
    SetPcgColor(Char_Wall, ColorPattern, Char_End - Char_Wall);
}


word PrintC(word vram, byte c)
{
    Put(vram, c - ' ');
    return vram + VramStep;
}


void DrawAll()
{
    EraseSprites();
    DrawSprites();
    SwapVram();
    // CallSound();
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            Put(vram, c);
            ++c;
            vram += VramStep;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Put2S(word vram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            Put(vram, *pChars);
            ++pChars;
            vram += VramStep;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            Put(vram, Char_Space);
            vram += VramStep;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Put2CXY(byte x, byte y, byte c)
{
    Put2C(VramAddress(x, y), c);
}


void Put2SXY(byte x, byte y, ptr<byte> pChars)
{
    Put2S(VramAddress(x, y), pChars);
}


// void Erase2XY(byte x, byte y)
// {
//     Erase2(VramAddress(x, y));
// }

