include "MemMap.inc"
include "Vram.inc"

ext SpritePattern_
ext FillMemory_

GVram equ 0c000h

dseg
GTop: public GTop
    defb 0

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push af | push hl | push de | push bc
        ld a,05h | out (GraphPort),a
        ld a,8fh | out (GraphPort+1),a

        ld hl,Vram
        ld de,VramWidth*VramHeight
        ld c,0
        call FillMemory_
        ld hl,Vram+1000h
        call FillMemory_
        ld hl,Vram+800h
        ld c,08h
        call FillMemory_

        ld a,10h or 80h | out (GraphPort),a
        xor a | out (GraphPort),a | out (GraphPort),a | out (GraphPort),a
        ld a,20h | ld (GTop),a
    pop bc | pop de | pop hl | pop af
ret


; word word VramAddress(byte x, byte y);
cseg
VramAddress_: public VramAddress_
    push af | push bc
        ld c,a
        ld a,e
        add a,a ;*2
        add a,a ;*4
        add a,e ;*5
        ld l,a
        ld h,0
        add hl,hl ;*10
        add hl,hl ;*20
        add hl,hl ;*40
        ld b,0
        add hl,bc
        ld bc,Vram
        add hl,bc
    pop bc | pop af
ret


cseg
PCGAddressHL:
    ld l,a
    ld h,0
    add hl,hl ;*2
    add hl,hl ;*4
    add hl,hl ;*8
    ld de,PCGAddress+800h
    add hl,de
ret


; void SetPcgMono(byte code, ptr<byte> pPattern, byte color, byte count);
dseg
SetPcgMono_@Param3: public SetPcgMono_@Param3
    defb 0
cseg
SetPcgMono_: public SetPcgMono_
    push af | push hl | push de | push bc
        exx
            call PCGAddressHL
        exx
        ld a,(SetPcgMono_@Param3)
        ld b,a
        do
            push bc
                ld b,3
                do
                    push de
                        ld h,CharHeight
                        do
                            ld a,(de) | inc de
                            ld l,0
                            bit 0,c
                            if nz
                                or l | ld l,a
                            endif
                            bit 4,c
                            if nz
                                cpl
                                or l | ld l,a
                            endif
                            ld a,l
                            exx
                                ld (hl),a | inc hl
                            exx
                            dec h
                        while nz | wend
                        exx
                            ld de,800h-CharHeight
                            add hl,de
                        exx
                        srl c
                    pop de
                dwnz
                ex de,hl
                    ld de,CharHeight
                    add hl,de
                ex de,hl
                exx
                    ld de,-800h*3+CharHeight
                    add hl,de
                exx
            pop bc
        dwnz
    pop bc | pop de | pop hl | pop af
ret


; void SetPcgColor(byte code, ptr<byte> pPattern, byte count);
cseg
SetPcgColor_: public SetPcgColor_
    push af | push hl | push de | push bc
        exx
            call PCGAddressHL
        exx
        ld b,c
        do
            push bc
                ld b,3
                do
                    ld h,CharHeight
                    do
                        ld a,(de) | inc de
                        exx
                            ld (hl),a | inc hl
                        exx
                        dec h
                    while nz | wend
                    exx
                        ld de,800h-CharHeight
                        add hl,de
                    exx
                dwnz
                exx
                    ld de,-800h*3+CharHeight
                    add hl,de
                exx
            pop bc
        dwnz
    pop bc | pop de | pop hl | pop af
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    ld (hl),e | inc hl
ret


; void SwapVram();
cseg
SwapVram_: public SwapVram_
    push af
        do
            ld a,(CRTPort)
            and 1
        while nz | wend

        ld a,11h | out (GraphPort),a
        ld a,(GTop) | out (GraphPort+1),a
        or a
        if z
            ld a,20h
        else
            xor a
        endif
        ld (GTop),a
    pop af
ret


GVramAddress:
    rrca | rrca | and 3fh
    ld b,a
    ld d,0
    ld l,e
    ld h,d
    add hl,hl ;*2
    add hl,hl ;*4
    add hl,de ;*5
    add hl,hl ;*10
    add hl,hl ;*20
    add hl,hl ;*40
    add hl,hl ;*80
    ld e,b
    ld d,0
    add hl,de
    ld de,GVram+VramWidth*CharHeight
    ld a,(GTop) | add a,d | ld d,a
    add hl,de
ret

BankG:
    di
        ld a,6 | out (MemMapPort),a
        ld a,MemMap_GVram | out (MemMapPort+1),a
        inc a | out (MemMapPort+1),a
    ei
ret

BankV:
    di
        ld a,6 | out (MemMapPort),a
        ld a,MemMap_PCG | out (MemMapPort+1),a
        ld a,MemMap_Text | out (MemMapPort+1),a
    ei
ret

EraseSprite_: public EraseSprite_
    push af | push hl | push de | push bc
        call GVramAddress
        call BankG

        ld a,4 or 80h | out (GraphPort),a
        ld a,0fh | out (GraphPort+1),a | out (GraphPort+1),a
        ld a,0ffh | out (GraphPort+1),a
        ld de,VramRowSize-3
        xor a
        ld c,16
        do
            ld b,3
            do
                ld (hl),a | inc hl
            dwnz
            add hl,de
            dec c
        while nz | wend
        call BankV
    pop bc | pop de | pop hl | pop af
ret

Shift:
    ld e,a
    ld d,0
    ld a,c
    or a
    do | while nz
       sla e | rl d
       dec a
    wend
ret

DrawSprite_: public DrawSprite_
    push af | push hl | push de | push bc
        exx
            ld c,a
        exx
        call GVramAddress
        call BankG

        ld a,c
        exx
            ld h,a
            ld l,0
            srl h | rr l
            ld de,SpritePattern_
            add hl,de

            ld a,c
            and 3
            add a,a
            ld c,a
        exx

        ld a,4 or 80h | out (GraphPort),a
        ld a,0fh | out (GraphPort+1),a
        out (GraphPort+1),a

        ld c,16
        do
            ld b,2
            do
                ld a,6 | out (GraphPort),a
                exx
                    ld a,(hl) | inc hl
                    call Shift
                    ld a,e | out (GraphPort+1),a
                    ld b,a
                exx
                ld a,0 or 80h| out (GraphPort),a
                ld e,3
                do
                    exx
                        ld a,(hl) | inc hl
                        call Shift
                        ld a,e | out (GraphPort+1),a
                    exx
                    dec e
                while nz | wend
                exx
                    ld a,b | out (GraphPort+1),a
                exx
                ld a,0ffh | ld (hl),a
                inc hl
                ld a,6 | out (GraphPort),a
                exx
                    dec hl | dec hl | dec hl | dec hl
                    ld a,(hl) | inc hl
                    call Shift
                    ld a,d | out (GraphPort+1),a
                    ld b,a
                exx
                ld a,0 or 80h| out (GraphPort),a
                ld e,3
                do
                    exx
                        ld a,(hl) | inc hl
                        call Shift
                        ld a,d | out (GraphPort+1),a
                    exx
                    dec e
                while nz | wend
                exx
                    ld a,b | out (GraphPort+1),a
                exx
                ld a,0ffh | ld (hl),a
            dwnz
            ld de,VramRowSize-2
            add hl,de
            dec c
        while nz | wend
        call BankV
    pop bc | pop de | pop hl | pop af
ret
